package FFRIndexed::Template::Plugin::ImageThumbnail;
use strict;
use base 'FFRIndexed::Template::Plugin';
use vars qw($VERSION);
$VERSION = '0.06';

=head1 NAME

FFRIndexed::Template::Plugin::ImageThumbnail - display a thumbnail view

=cut

__PACKAGE__->visual( 'as thumbnail' );
__PACKAGE__->content_type('image/jpeg');
__PACKAGE__->types({
  item => 'image_thumbnail'
});

sub applies {
  my ($self, $query, $resultset, $refinements, $row) = @_;

  return
    unless $row;
  return unless $row->mime_type =~ m!^image/!i;

  # We should try to find an appropriate thumbnail
  # instead of just using the image itself:
  my $thumbnail;

  eval {
      warn "Looking for thumbnail";

      my $res = $row->_index->query_ex(
                          where => { #album => $row->album,
                                     title => $row->album,
                                     artist => $row->artist,
                                     width => { '<' => 100 }
                                     });

      $thumbnail = $res->[0];

      if ($thumbnail) {
        warn "$thumbnail";
      } else {
        warn "Didn't find a suitable thumbnail for $row";
      };
  };
  warn $@
    if $@;

  # In theory we'd create the thumbnail here

  return $thumbnail || $row;
};

1;
